% Forward modeling of 2D exploding water surface 
%parameters
ESIZE=200; % width of experiment(# of vertices, notice # of surfaces/rays is ESIZE-1)
DMAX=400; % maximum depth of projection
%end of parameters
SLICE=250;%250 for precaustics

% building the surface function
sSurface = zeros(ESIZE,1);

for i=1:ESIZE
    jj=i*2.05;
    % You can change this to any function of i
    %sSurface(i) = 14*sin(0.005*i*pi+1.5);
    sSurface(i) = 1.25*sin(0.01*i*pi+1.5)+1.0*sin(0.02*i*pi+1.5);%2.5*sin(0.02*i*pi+1.5)
    %sSurface(i) = 3*(1.25*sin(0.01*i*pi+2)+1.02*sin(0.0201*i*pi+1.00));%2.5*sin(0.02*i*pi+1.5)
    %sSurface(i) = .2*(3*sin(0.04*jj*pi+1)+4*sin(0.02*jj*pi+2)+2*sin(0.03*jj*pi+1));%5*sin(10/(10+0.023*i)*180/pi);%*(i*0.010);
    %sSurface(i) = 3*sin(8.5/(10+0.040*i)*180/pi+4);
end
%sSurface=-Ptp; % from finite difference
%sSurface = -(ssurffix-saveSurface);
sSurface = sSurface-sSurface(1);

%end of building surface

%find the x-derivative
sssdrv=zeros(ESIZE-1,1);
for i=1:ESIZE-1
    sssdrv(i) = (sSurface(i+1)-sSurface(i));
end


%start building the projection matrix (the matrix holding the ray paths)
    curS=(1:(ESIZE-1))+0.5; % half way between two vertices.
    xmin=min(sSurface);
    xmax=max(sSurface);
    difference=abs(-xmin+1);% pad the the variations fo surface functions to the top of the matrix
    diff32=int32(difference);
    Projection=zeros(diff32+DMAX,ESIZE); % setup the image space
    for d=1:diff32+DMAX % d is depth from maximum of the surface function.
        for v=1:ESIZE-1
            if((d-diff32)>sSurface(v))
                curS(v)=curS(v)-sssdrv(v);
                tmpX=int32(curS(v));
                if( tmpX > 0 && tmpX < ESIZE)
                    Projection(d,tmpX)=Projection(d,tmpX)+1;
                end
            end
        end
    end
SUPERMAX=max(max(Projection)); % scaling factor
for i=1:ESIZE
    tmpX=int32(sSurface(i))+diff32;
    if(tmpX>0)
        Projection(1:tmpX,i)=-10;
        Projection(tmpX,i)=10;
    end
end

subplot(6,2,1);
plot(-sSurface,'Color',[0 0 0]);ylabel('Z (cm)','Fontsize', 12);%ylim([0 max(-sSurface)])
intensity=Projection(SLICE,:);
subplot(6,2,[ 3 5 7 9]);
imagesc(Projection(1:SLICE+diff32,:),[0 SUPERMAX]);figure(gcf);title('');ylabel('Z (cm)','Fontsize', 12);
subplot(6,2,11);
bar(intensity,1,'FaceColor',[0.502 0.502 0.502]);ylabel('Ray Count','Fontsize', 12); xlabel('X (cm)','Fontsize', 12);xlim([1 ESIZE]);
