!A program to build arbitrary 2D surfaces
program build2dsurface
use sep
use water2dlib
implicit none
  integer  :: n1, choise
  real, dimension(:), allocatable :: data
  !counters and temprorary variables
  integer :: ii
  call sep_init();
  call from_param("n1", n1, 100);
  call from_param("choise", choise, 1);
  allocate(data(n1));
  do ii=1, n1
    select case(choise)
      case (1) ! simple sinsoidal
           data(ii) = 2*12.0+2*8.0 * cos(ii*.032);
      case (2) ! simple sinsoidal
           data(ii) = 20.-20.*exp(-((n1/2-ii)/(n1/10.))**2.) 
      case (3) ! for full sampling inv
           data(ii) = 11.0+14.0 * sin(ii*.05+PI/6) &
                    + 8.*sin(ii *.025);
      case (4) ! for exp test
           data(ii) = exp(-1.*abs(1.*ii-n1/2));
    end select
  enddo
  call to_history("label1","x(cm)");
  call to_history("label2","z(cm)");
  call to_history("n1", n1);
  call sep_write(data);
  deallocate(data)
end program
