% 3d snells
%parameters
SrcX=0;
SrcY=0;
SrcZ=-100.5;
tfunc=5; % choise of a surface function see the switch command
ESIZE=500; % width of experiment
DMAX=50; % maximum depth of projection
CAIR=1.0;
CWTR=1.333;
sSurface = zeros(ESIZE,ESIZE);
shadow=zeros(ESIZE);
t=20;
figure('visible','off')
% building the surface function
for i=1:ESIZE
    for j=1:ESIZE
        switch(tfunc)%Choose a surface function of the ones below or make your own
            case 0 % nothing flat surface                
            case 1 % Gaussian anamoly
                sSurface(i,j) =-1/sqrt(2*pi)*50*exp(-((4*t-i)^2+(4*t-j)^2)/30^2);
            case 2 %dens sinsoidal function
                sSurface(i,j) = sin(12/(10+0.02*i)*180/pi+j*.4-.4*sqrt(4*t))*1.5;
            case 3 % loose sinsidal function
                sSurface(i,j) = 3*sin(12/(10+0.02*i)*180/pi+j*.05-.4*sqrt(4*t));
            case 5 % The realistic one 3 sinsoidal functions superposed
               %firts wave
                x=200;y=200;z=sqrt((i-x)^2+(j-y)^2);
                sSurface(i,j)=              -9.0*exp(-z/140)*cos(0.09*z);
                x=400;y=400;z=sqrt((i-x)^2+(j-y)^2);
                sSurface(i,j)=sSurface(i,j)+6.0*exp(-z/500)*cos(0.07*z);
                %second one
                x=200;y=800;z=sqrt((i-x)^2+(j-y)^2);
                sSurface(i,j)=sSurface(i,j)-10*exp(-z/130)*cos(0.03*z);
                %third one
                x=800;y=200;z=sqrt((i-x)^2+(j-y)^2);
                sSurface(i,j)=sSurface(i,j)-15*exp(-z/150)*cos(0.05*z);
                %fourth one
                x=-200;y=200;z=sqrt((i-x)^2+(j-y)^2);
                sSurface(i,j)=sSurface(i,j)-5*exp(-z/90)*cos(0.03*z);
                %fifth one
                x=200;y=-200;z=sqrt((i-x)^2+(j-y)^2);
                sSurface(i,j)=sSurface(i,j)+20*exp(-z/150)*cos(0.08*z);
 
        end
    end
end
%imagesc(-sSurface);colorbar;break
%end of building surface

%NOTE THAT BOUNDARIES HAVE ZERO VALUES
%find the x and y-derivatives
sssdrvx=zeros(ESIZE);
sssdrvy=zeros(ESIZE);
nmag=zeros(ESIZE);%magnitude of surface normal ray(normalized for z)
rx=zeros(ESIZE); % refracted ray x component
ry=zeros(ESIZE); % refracted ray y component
rmag=zeros(ESIZE);%magnitude of incident ray(normalized for z)

for i=2:ESIZE-1
    for j=2:ESIZE-1
        sssdrvx(i,j) = (sSurface(i,j+1)-sSurface(i,j-1))/2;
        sssdrvy(j,i) = (sSurface(j+1,i)-sSurface(j-1,i))/2;
        nmag(i,j)=sqrt(sssdrvx(i,j)^2+sssdrvy(i,j)^2+1);
        %computing the incident ray from source to each point
        rx(i,j)=(i-SrcX)/(sSurface(i,j)+SrcZ);
        ry(i,j)=(j-SrcY)/(sSurface(i,j)+SrcZ);
        rmag(i,j)=sqrt(rx(i,j)^2+ry(i,j)^2+1);
    end
    %sssdrvx(i,1)=sssdrvx(i,2)+(sssdrvx(i,2)-sssdrvx(i,3));
    %sssdrvx(i,ESIZE)=sssdrvx(i,ESIZE-1)+(sssdrvx(i,ESIZE-1)-sssdrvx(i,ESIZE-2));
    %sssdrvy(1,i)=sssdrvy(2,i)+(sssdrvy(2,i)-sssdrvy(3,i));
    %sssdrvy(ESIZE,i)=sssdrvy(ESIZE-1,i)+(sssdrvy(ESIZE-1,i)-sssdrvy(ESIZE-2,i));
end
%end of computing ther drivatives
%end of computing the incident ray

%computing the normal of snells plane
xdrv=zeros(ESIZE);
ydrv=zeros(ESIZE);
pmag=zeros(ESIZE);%angle of snells plane normal with horizontal
for i=2:ESIZE-1
   for j=2:ESIZE-1
       px=ry(i,j)+sssdrvy(i,j);
       py=-rx(i,j)-sssdrvx(i,j);
       pz=-rx(i,j)*sssdrvy(i,j)+ry(i,j)*sssdrvx(i,j);
       pmag(i,j)=acos(-(pz)/(sqrt(px^2+py^2+pz^2)*sqrt(2)))*180/pi;
       %end of computing the incident ray
       %computing n.r and the left hand side of snells law
       ndotr=(rx(i,j)*sssdrvx(i,j)+ry(i,j)*sssdrvy(i,j)+1)/(nmag(i,j)*rmag(i,j));
       sign=ndotr/abs(ndotr);
       if(sign<0)
           shadow(i,j)=1;
       else
           C2=(CAIR/CWTR)*sqrt(1-(ndotr^2));
           C3=nmag(i,j)*sqrt(1-C2^2);
           triangleCom=C3*(py^2*(1-C3+sssdrvx(i,j)^2)+2*py*pz*sssdrvy(i,j)+2*px*sssdrvx(i,j)*(pz-py*sssdrvy(i,j))+px^2*(1-C3+sssdrvy(i,j)^2)+pz^2*(-C3+sssdrvx(i,j)^2+sssdrvy(i,j)^2));
           triX=sqrt(triangleCom*py^2);
           triY=sqrt(triangleCom*px^2);
           strX=-C3*py*pz-(px+pz*sssdrvx(i,j))*(-py*sssdrvx(i,j)+px*sssdrvy(i,j));
           strY=-C3*px*pz-(py+pz*sssdrvy(i,j))*(py*sssdrvx(i,j)-px*sssdrvy(i,j));
           sqr=C3*(px^2+py^2)-(py*sssdrvx(i,j)-px*sssdrvy(i,j))^2;% the same for Xdrv and Ydrv
           %computing r.grad(Surface)
           qtr1=ry(i,j)+sssdrvy(i,j);
           if(qtr1<0)
                 ydrv(i,j)=(strY+triY)/sqr;
           else
               ydrv(i,j)=(strY-triY)/sqr;
           end
           qtr2=rx(i,j)+sssdrvx(i,j);
           if(qtr2<0)
               xdrv(i,j)=(strX+triX)/sqr;
           else
               xdrv(i,j)=(strX-triX)/sqr;
           end
       end
   end
end
% Setting up current X&Y-position of each vector
curSX=zeros(ESIZE,ESIZE);
curSY=zeros(ESIZE,ESIZE);
for i=1:ESIZE
    curSX(i,:)=1:ESIZE;
    curSY(:,i)=1:ESIZE;
end
%start building the projection matrix (the matrix holding the ray
xmin=min(min(sSurface));
xmax=max(max(sSurface));
difference=abs(xmax);
diff32=int32(difference);% pad the the variations fo surface functions to the top of the matrix
Projection=zeros(diff32+DMAX, ESIZE, ESIZE,'int8'); % setup the image space
disp( 'Starting scattering')
for d=1:size(Projection,1) % depth from mean surface
    for vi=1:ESIZE
        for vj=1:ESIZE
            if((d-diff32)>sSurface(vi,vj) && shadow(vi,vj)==0)
                curSX(vi,vj)=curSX(vi,vj)+ydrv(vi,vj);
                curSY(vi,vj)=curSY(vi,vj)+xdrv(vi,vj);
                tmpX=int16(curSX(vi,vj));
                tmpY=int16(curSY(vi,vj));
                if( tmpX > 0 && tmpX < ESIZE && tmpY > 0 && tmpY<ESIZE)
                    Projection(d,tmpX, tmpY)=Projection(d,tmpX, tmpY)+1;%mod(vj,10)+mod(vi,10);
                end
            end
        end
    end
    disp(strcat('@depth :',int2str(d)))
end
for i=1:ESIZE
    for j=1:ESIZE
        Projection(1:int32(sSurface(i,j))+diff32+1,i,j)=10;
    end
end
colormap gray
subplot(2,2,1);
imagesc(abs(max(max(sSurface))-min(min(sSurface)))+sSurface);title('Surface Depth','Fontsize', 12);xlabel('x (cm)','Fontsize', 12);ylabel('y (cm)','Fontsize', 12);
subplot(2,2,3);
%plot the x-slice
%                       v x-slice at 60
imagesc(Projection(:,:,410));caxis([0 9]);title('Cross-section (y=410)','Fontsize', 12);xlabel('x (cm)','Fontsize', 12);ylabel('z (cm)','Fontsize', 12);
%set(gca,'YTick',[1:10:70],'YTickLabels',[-0:-10:-70])
subplot(2,2,4);
%                             v y-slice at 60
%plot the y-slice
display=reshape(Projection(:,250,:), size(Projection,1),ESIZE);
imagesc(display);caxis([0 9]);title('Cross-section (x=250)','Fontsize', 12);xlabel('y (cm)','Fontsize', 12);ylabel('z (cm)','Fontsize', 12);
%set(gca,'YTick',[1:10:70],'YTickLabels',[-0:-10:-70])
subplot(2,2,2);
%plot the z-slice
%                                     v depth slice at 25
display=transpose(reshape(Projection(DMAX,:,:), ESIZE, ESIZE));
imagesc(display);title('Intensity Field at Pool Floor','Fontsize', 12);xlabel('x (cm)','Fontsize', 12);ylabel('y (cm)','Fontsize', 12);
caxis([0 9]);
colorbar off;
print -deps2 fig_snells3d.ps
%exit;
